#pragma comment(lib, "XInput.lib")
#include <Windows.h>
#include <Xinput.h>
#include <iostream>
#include "gamepad.h"



	XINPUT_STATE state;
	
	struct PrevStates
	{
		int A, B, X, Y, RT, LT, ST, BACK, RS, LS;
	};

	enum Buttons
	{
		A,B,X,Y,RB,LB,ST,BACK,RS,LS
	};

	PrevStates prev[4];

void main()
{
	

	ZeroMemory(&state, sizeof(XINPUT_STATE));
	
	bool game = true;
	while (game)
	{
		for (int i = 0; i <= sizeof(XINPUT_STATE); i++)
		{ 
			if (isConnected(i))
			{
				if (getButtonPressed(i, A))
				{
					std::cout << "Player " << i << " Holding A" << std::endl;
				}
			}
		}
		gamePadUpdate();
	}
}

void gamePadUpdate()
{
	for (int i = 0; i <= sizeof(XINPUT_STATE); i++)
	{
		if (isConnected(i))
		{
			prev->A = (state.Gamepad.wButtons & XINPUT_GAMEPAD_A);
			prev->B = (state.Gamepad.wButtons & XINPUT_GAMEPAD_B);
			prev->X = (state.Gamepad.wButtons & XINPUT_GAMEPAD_X);
			prev->Y = (state.Gamepad.wButtons & XINPUT_GAMEPAD_Y);
			prev->ST = (state.Gamepad.wButtons & XINPUT_GAMEPAD_START);
			prev->BACK = (state.Gamepad.wButtons & XINPUT_GAMEPAD_BACK);
			prev->RS = (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB);
			prev->LS = (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB);
		}
	}
}

bool isConnected(int gamepadIndex)
{
	if (XInputGetState(gamepadIndex, &state) == ERROR_SUCCESS)
	{
		return true;
	}
	return false;
}

bool getButtonDown(int gamepadIndex, int Button)
{
	
	if (Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) != 0)
	{
		return true;
	}
	return false;
}

bool getButtonUp(int gamepadIndex, int Button)
{
	if (Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) == 0)
	{
		return true;
	}
	return false;
}

bool getButtonPressed(int gamepadIndex, int Button)
{

	if (prev[gamepadIndex].A == 0 && Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) != 0)
	{
		return true;
	}
	return false;
}

