#include "Wrapper.h"
#pragma comment(lib, "XInput.lib")
#include <Windows.h>
#include <Xinput.h>
#include <iostream>

XINPUT_STATE state;

struct PrevStates
{
	int A, B, X, Y, RB, LB, ST, BACK, RS, LS , DPR, DPL, DPU, DPD;
};

enum Buttons
{
	A, B, X, Y, RB, LB, ST, BACK, RS, LS, DPR, DPL, DPU, DPD, LEFT_STICK, RIGHT_STICK, LT, RT
};

PrevStates prev[16];

void init()
{
	ZeroMemory(&state, sizeof(XINPUT_STATE));
}

int numGamePads()
{
	return sizeof(XINPUT_STATE);
}


void gamePadUpdate()
{
	for (int i = 0; i <= sizeof(XINPUT_STATE); i++)
	{
		if (isConnected(i))
		{
			prev[i].A = (state.Gamepad.wButtons & XINPUT_GAMEPAD_A);
			prev[i].B = (state.Gamepad.wButtons & XINPUT_GAMEPAD_B);
			prev[i].X = (state.Gamepad.wButtons & XINPUT_GAMEPAD_X);
			prev[i].Y = (state.Gamepad.wButtons & XINPUT_GAMEPAD_Y);
			prev[i].ST = (state.Gamepad.wButtons & XINPUT_GAMEPAD_START);
			prev[i].BACK = (state.Gamepad.wButtons & XINPUT_GAMEPAD_BACK);
			prev[i].RB = (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_SHOULDER);
			prev[i].LB = (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_SHOULDER);
			prev[i].RS = (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB);
			prev[i].LS = (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB);
			prev[i].DPD = (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN);
			prev[i].DPU = (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP);
			prev[i].DPL = (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT);
			prev[i].DPR = (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT);
		}
	}
}

bool isConnected(int gamepadIndex)
{
	if (XInputGetState(gamepadIndex, &state) == ERROR_SUCCESS)
	{
		return true;
	}
	return false;
}

bool getButtonDown(int gamepadIndex, int Button)
{
	if (isConnected(gamepadIndex))
	{
		if (Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) != 0)
		{
			return true;
		}
		if (Button == B && (state.Gamepad.wButtons & XINPUT_GAMEPAD_B) != 0)
		{
			return true;
		}
		if (Button == X && (state.Gamepad.wButtons & XINPUT_GAMEPAD_X) != 0)
		{
			return true;
		}
		if (Button == Y && (state.Gamepad.wButtons & XINPUT_GAMEPAD_Y) != 0)
		{
			return true;
		}
		if (Button == RB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_SHOULDER) != 0)
		{
			return true;
		}
		if (Button == LB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_SHOULDER) != 0)
		{
			return true;
		}
		if (Button == ST && (state.Gamepad.wButtons & XINPUT_GAMEPAD_START) != 0)
		{
			return true;
		}
		if (Button == BACK && (state.Gamepad.wButtons & XINPUT_GAMEPAD_BACK) != 0)
		{
			return true;
		}
		if (Button == RS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB) != 0)
		{
			return true;
		}
		if (Button == LS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB) != 0)
		{
			return true;
		}
		if (Button == DPD && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN) != 0)
		{
			return true;
		}
		if (Button == DPU && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP) != 0)
		{
			return true;
		}
		if (Button == DPL && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT) != 0)
		{
			return true;
		}
		if (Button == DPR && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT) != 0)
		{
			return true;
		}	
	}
	return false;
}

bool getButtonUp(int gamepadIndex, int Button)
{
	if (isConnected(gamepadIndex))
	{
		if (Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) == 0)
		{
			return true;
		}
		if (Button == B && (state.Gamepad.wButtons & XINPUT_GAMEPAD_B) == 0)
		{
			return true;
		}
		if (Button == X && (state.Gamepad.wButtons & XINPUT_GAMEPAD_X) == 0)
		{
			return true;
		}
		if (Button == Y && (state.Gamepad.wButtons & XINPUT_GAMEPAD_Y) == 0)
		{
			return true;
		}
		if (Button == RB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_SHOULDER) == 0)
		{
			return true;
		}
		if (Button == LB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_SHOULDER) == 0)
		{
			return true;
		}
		if (Button == ST && (state.Gamepad.wButtons & XINPUT_GAMEPAD_START) == 0)
		{
			return true;
		}
		if (Button == BACK && (state.Gamepad.wButtons & XINPUT_GAMEPAD_BACK) == 0)
		{
			return true;
		}
		if (Button == RS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB) == 0)
		{
			return true;
		}
		if (Button == LS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB) == 0)
		{
			return true;
		}
		if (Button == DPD && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN) == 0)
		{
			return true;
		}
		if (Button == DPU && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP) == 0)
		{
			return true;
		}
		if (Button == DPL && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT) == 0)
		{
			return true;
		}
		if (Button == DPR && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT) == 0)
		{
			return true;
		}
	}
	return false;
}

bool getButtonPressed(int gamepadIndex, int Button)
{

	if (isConnected(gamepadIndex))
	{
		if (prev[gamepadIndex].A == 0 && (Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) != 0))
		{
			return true;
		}
		if (prev[gamepadIndex].B == 0 && Button == B && (state.Gamepad.wButtons & XINPUT_GAMEPAD_B) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].X == 0 && Button == X && (state.Gamepad.wButtons & XINPUT_GAMEPAD_X) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].Y == 0 && Button == Y && (state.Gamepad.wButtons & XINPUT_GAMEPAD_Y) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].RB == 0 && Button == RB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_SHOULDER) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].LB == 0 && Button == LB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_SHOULDER) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].ST == 0 && Button == ST && (state.Gamepad.wButtons & XINPUT_GAMEPAD_START) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].BACK == 0 && Button == BACK && (state.Gamepad.wButtons & XINPUT_GAMEPAD_BACK) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].RS == 0 && Button == RS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].LS == 0 && Button == LS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPD == 0 && Button == DPD && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPD == 0 && Button == DPU && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPL == 0 && Button == DPL && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT) != 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPR == 0 && Button == DPR && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT) != 0)
		{
			return true;
		}
	}
	return false;
}

bool getButtonReleased(int gamepadIndex, int Button)
{
	if (isConnected(gamepadIndex))
	{
		if (prev[gamepadIndex].A != 0 && Button == A && (state.Gamepad.wButtons & XINPUT_GAMEPAD_A) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].B != 0 && Button == B && (state.Gamepad.wButtons & XINPUT_GAMEPAD_B) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].X != 0 && Button == X && (state.Gamepad.wButtons & XINPUT_GAMEPAD_X) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].Y != 0 && Button == Y && (state.Gamepad.wButtons & XINPUT_GAMEPAD_Y) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].RB != 0 && Button == RB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_SHOULDER) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].LB != 0 && Button == LB && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_SHOULDER) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].ST != 0 && Button == ST && (state.Gamepad.wButtons & XINPUT_GAMEPAD_START) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].BACK != 0 && Button == BACK && (state.Gamepad.wButtons & XINPUT_GAMEPAD_BACK) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].RS != 0 && Button == RS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].LS != 0 && Button == LS && (state.Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPD != 0 && Button == DPD && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPU != 0 && Button == DPU && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPL != 0 && Button == DPL && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT) == 0)
		{
			return true;
		}
		if (prev[gamepadIndex].DPR != 0 && Button == DPR && (state.Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT) == 0)
		{
			return true;
		}
	}
	return false;
}

float getAxis(int gamepadIndex, int button , int axis)
{
	if (isConnected(gamepadIndex))
	{
		if (button == LEFT_STICK)
		{
			if (axis == X)
			{
				return (state.Gamepad.sThumbLX / 32767.0f);
			}
			if (axis == Y)
			{
				return (state.Gamepad.sThumbLY / 32767.0f);
			}
		}
		if (button == RIGHT_STICK)
		{
			if (axis == X)
			{
				return (state.Gamepad.sThumbRX / 32767.0f);
			}
			if (axis == Y)
			{
				return (state.Gamepad.sThumbRY / 32767.0f);
			}
		}
		if (button == LT)
		{
			return state.Gamepad.bLeftTrigger;
		}
		if (button == RT)
		{
			return state.Gamepad.bRightTrigger;
		}
	}
	return 0.0;
}

