﻿using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System;
using UnityEngine;


public class Controller : MonoBehaviour
{
    [DllImport("ControllerTest")]
    public static extern void init();

    [DllImport("ControllerTest")]
    public static extern int numGamePads();

    [DllImport("ControllerTest")]
    public static extern bool isConnected(int gamepadIndex);

    [DllImport("ControllerTest")]
    public static extern bool getButtonDown(int gamepadIndex, int Button);

    [DllImport("ControllerTest")]
    public static extern bool getButtonUp(int gamepadIndex, int Button);

    [DllImport("ControllerTest")]
    public static extern bool getButtonPressed(int gamepadIndex, int Button);

    [DllImport("ControllerTest")]
    public static extern bool getButtonReleased(int gamepadIndex, int Button);

    [DllImport("ControllerTest")]
    public static extern void gamePadUpdate();

    [DllImport("ControllerTest")]
    public static extern float getAxis(int gamepadIndex, int button, int axis = 0);

    public GameObject prefab;

    GameObject[] clone = new GameObject[16];

    public static bool[] currentNumber = new bool[16];

    public enum button
    {
        A, B, X, Y, RB, LB, ST, BACK, RS, LS, DPR, DPL, DPU, DPD, LEFT_STICK, RIGHT_STICK, LT, RT
    }

    // Use this for initialization
    void Start()
    {
        init();
    }


    // Update is called once per frame
    void Update()
    {
        for (int i = 0; i < numGamePads(); i++)
        {
            for (int k = 0; k < 4; k++)
            {

                if (getButtonDown(i, k) && !currentNumber[k])
                {
                    currentNumber[k] = false;
                    clone[k] = Instantiate(prefab);
                    clone[k].name = k.ToString();
                    clone[k].GetComponent<loadPic>().draw(k, clone[k]);
                    print(currentNumber);
                }
                else if (getButtonReleased(i, k) && clone[k] != null && clone[k].name == k.ToString())
                {
                    print(i + " Released A");
                    Destroy(clone[k].gameObject);
                    currentNumber[k] = true;
                }
            }
        }
        gamePadUpdate();
    }

}
